'CSC 230 Example Sept. 2005
'Weekly Payroll Example 

'demonstrates Select case statement (VB's version of a "switch")

'also introduces trim and format as currency

Public Class FrmPayroll

    Const OVERTIME As Integer = 40
    'If one works more than OVERTIME (40) hours, one earns overtime
    Dim Total As Double = 0     'totals the amount paid by the restaurant

    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        Dim Hours As Integer            'hours worked by an employee
        Dim HourlyRate As Double        'hourly rate an employee earns
        Dim WeeklyPay As Double         'salary employee earns in a week

        'see if user entered number in textbox for hours
        If IsNumeric(txtHours.Text) Then
            Hours = CInt(txtHours.Text)
        Else
            MsgBox("Please enter the number of hours worked.")
            txtHours.Clear()
            txtHours.Focus()
            Exit Sub
        End If

        'see if user entered something in name textbox
        If txtName.Text = "" Then
            MsgBox("Please enter a name.")
            txtName.Focus()
            Exit Sub
        End If

        'see if user selected a level
        If cboLevel.Text = "Select a level" Then
            MsgBox("Please select a level.")
            cboLevel.Focus()
            Exit Sub
        End If

        'use a Select Case statement to determine 
        'the hourly rate of the employee based on 
        'the selected level
        Select Case cboLevel.Text.Trim
            'the trim method eliminates "white space" 
            'from the beginning and end of a string 
            Case "Cook 1"
                HourlyRate = 5.9
            Case "Cook 2"
                HourlyRate = 6.8
            Case "Cashier"
                HourlyRate = 7.8
            Case "Head Cashier"
                HourlyRate = 8.8
            Case "Waiter/Waitress"
                HourlyRate = 6.8
            Case "Head Waiter/Waitress"
                HourlyRate = 7.8
            Case "Assistant Manager"
                HourlyRate = 10.8
            Case "Manager"
                HourlyRate = 12.8
        End Select

        'calculate weekly salary 
        'uses time and a half when employees 
        'work overtime
        If Hours <= OVERTIME Then
            WeeklyPay = HourlyRate * Hours
        Else
            WeeklyPay = OVERTIME * HourlyRate + (Hours - OVERTIME) * HourlyRate * 1.5
        End If

        'keep a running total
        Total += WeeklyPay

        'display the information in the textbox (Read-Only)
        txtPayroll.Text &= txtName.Text & " (" & cboLevel.Text & ") "
        txtPayroll.Text &= Hours & " hours @ " & Format(HourlyRate, "Currency")
        txtPayroll.Text &= " = " & Format(WeeklyPay, "Currency") & vbCrLf
        'The Format function will inform the application 
        'how to display the number -- the first argument is 
        'the number to be displayed and the second argument 
        'is the way in which it should be displayed

        'display the running total
        lblTotal.Text = Format(Total, "Currency")

        'prepare interface for next entry
        txtName.Clear()
        txtHours.Clear()
        cboLevel.Text = "Select a level"
    End Sub
End Class
